package data

import (
	resources "cloud.o-forge.io/core/oc-lib/models/resources"
	"cloud.o-forge.io/core/oc-lib/models/utils"
)

type Data struct {
	resources.AbstractResource
	Protocols []string `json:"protocol,omitempty" bson:"protocol,omitempty"` //TODO Enum type
	DataType  string   `json:"datatype" required:"true" bson:"datatype"`
	Example   string   `json:"example" bson:"example" required:"true" validate:"required" description:"base64 encoded data"`
}

func (d *Data) GetType() resources.ResourceType {
	return resources.DATA
}

func (d *Data) GetAccessor(driver utils.Driver) utils.Accessor {
	var data utils.Accessor
	switch driver {
	case utils.MONGO:
		data = &DataMongoAccessor{}
	default:
		data = &DataMongoAccessor{}
	}
	data.SetLogger()
	return data
}
