package data

import (
	mongo "cloud.o-forge.io/core/oc-lib/dbs/mongo"
	"cloud.o-forge.io/core/oc-lib/models/utils"
)

type DataMongoAccessor struct {
	utils.AbstractAccessor
}

func (dma *DataMongoAccessor) DeleteOne(id string) utils.DBObject {
	return dma.GenericDeleteOne(id, dma)
}

func (dma *DataMongoAccessor) UpdateOne(set map[string]interface{}, id string) utils.DBObject {
	return dma.GenericUpdateOne(set, id, dma)
}

func (dma *DataMongoAccessor) StoreOne(data utils.DBObject) utils.DBObject {
	id, err := mongo.MONGOService.StoreOne(data.(*Data), "data")
	if err != nil {
		dma.Logger.Error().Msg("Could not store " + data.GetName() + " to db. Error: " + err.Error())
		return &Data{}
	}
	return dma.LoadOne(id)
}

func (dma *DataMongoAccessor) LoadOne(id string) utils.DBObject {
	var data Data
	res_mongo, err := mongo.MONGOService.LoadOne(id, "data")
	if err != nil {
		dma.Logger.Error().Msg("Could not retrieve " + id + " from db. Error: " + err.Error())
		return &Data{}
	}
	res_mongo.Decode(&data)

	return &data
}
