package storage

import (
	"cloud.o-forge.io/core/oc-lib/dbs/mongo"
	"cloud.o-forge.io/core/oc-lib/logs"
	"cloud.o-forge.io/core/oc-lib/models/utils"
)

type StorageMongoAccessor struct {
	utils.AbstractAccessor
}

func (dma *StorageMongoAccessor) DeleteOne(id string) utils.DBObject {
	return dma.GenericDeleteOne(id, dma)
}

func (dma *StorageMongoAccessor) UpdateOne(set map[string]interface{}, id string) utils.DBObject {
	return dma.GenericUpdateOne(set, id, dma)
}

func (dma *StorageMongoAccessor) StoreOne(data utils.DBObject) utils.DBObject {
	id, err := mongo.MONGOService.StoreOne(data.(*Storage), "data")
	if err != nil {
		dma.Logger.Error().Msg("Could not store " + data.GetName() + " to db. Error: " + err.Error())
		return &Storage{}
	}
	return dma.LoadOne(id)
}

func (schedulema *StorageMongoAccessor) LoadOne(id string) utils.DBObject {

	var storage Storage

	res_mongo, err := mongo.MONGOService.LoadOne(id, "storage")
	if err != nil {
		l := logs.CreateLogger("oclib", "")
		l.Error().Msg("Could not retrieve " + id + " from db. Error: " + err.Error())
		return &Storage{}
	}

	res_mongo.Decode(&storage)

	return &storage
}
