package utils

type DBObject interface {
	GetName() string
	GetAccessor(driver Driver) Accessor
}

type Accessor interface {
	SetLogger()
	LoadOne(id string) DBObject
	DeleteOne(id string) DBObject
	StoreOne(data DBObject) DBObject
	UpdateOne(set map[string]interface{}, id string) DBObject
}
