package oclib

import (
	"cloud.o-forge.io/core/oc-lib/dbs/mongo"
	"cloud.o-forge.io/core/oc-lib/logs"
	"cloud.o-forge.io/core/oc-lib/models/utils"
)

type WorkflowMongoAccessor struct {
	utils.AbstractAccessor
}

func (dma *WorkflowMongoAccessor) DeleteOne(id string) utils.DBObject {
	return dma.GenericDeleteOne(id, dma)
}

func (dma *WorkflowMongoAccessor) UpdateOne(set map[string]interface{}, id string) utils.DBObject {
	return dma.GenericUpdateOne(set, id, dma)
}

func (dma *WorkflowMongoAccessor) StoreOne(data utils.DBObject) utils.DBObject {
	id, err := mongo.MONGOService.StoreOne(data.(*Workflow), "data")
	if err != nil {
		dma.Logger.Error().Msg("Could not store " + data.GetName() + " to db. Error: " + err.Error())
		return &Workflow{}
	}
	return dma.LoadOne(id)
}

func (wfa *WorkflowMongoAccessor) LoadOne(id string) utils.DBObject {
	var workflow Workflow

	res_mongo, err := mongo.MONGOService.LoadOne(id, "workflow")
	if err != nil {
		l := logs.CreateLogger("oclib", "")
		l.Error().Msg("Could not retrieve " + id + " from db. Error: " + err.Error())
		return &Workflow{}
	}

	res_mongo.Decode(&workflow)

	return &workflow
}
