package oclib

import (
	"testing"

	"cloud.o-forge.io/core/oc-lib/models/resources"

	"github.com/stretchr/testify/assert"
)

func TestStoreOneWorkflow(t *testing.T) {
	w := Workflow{AbstractResource: resources.AbstractResource{
		Uuid:        "123",
		Name:        "testWorkflow",
		Description: "Lorem Ipsum",
		Logo:        "azerty.com",
		Owner:       "toto",
		OwnerLogo:   "totoLogo",
		SourceUrl:   "azerty.fr",
	},
	}

	wma := WorkflowMongoAccessor{}
	id := wma.StoreOne(&w)

	assert.NotEmpty(t, id)
}

func TestLoadOneWorkflow(t *testing.T) {
	w := Workflow{AbstractResource: resources.AbstractResource{
		Uuid:        "123",
		Name:        "testWorkflow",
		Description: "Lorem Ipsum",
		Logo:        "azerty.com",
		Owner:       "toto",
		OwnerLogo:   "totoLogo",
		SourceUrl:   "azerty.fr",
	},
	}

	wma := WorkflowMongoAccessor{}
	new_w := wma.StoreOne(&w)
	assert.Equal(t, w, new_w)
}
